<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;">
<meta http-equiv="Content-Style-Type" content="text/css">
<title>AttachMOD installer</title>
<style type="text/css">
<!--

font,th,td,p,body { font-family: "Trebuchet MS", Verdana, Arial,  sans-serif; font-size: 15px }

a:link,a:active,a:visited { color : #006699; }
a:hover		{ text-decoration: underline; color : #DD6900;}

hr	{ height: 0px; border: solid #D1D7DC 0px; border-top-width: 1px;}

.maintitle	{font-weight: bold; font-size: 22px; font-family: "Trebuchet MS", Verdana, Arial,  sans-serif; text-decoration: none; line-height : 120%; color : #000000;}

.ok {color:green}

input { text-indent : 2px; }

/* The buttons used for bbCode styling in message post */
input.button {
	background-color : #EFEFEF;
	color : #000000;
	font-size: 11px; font-family: Verdana, Arial,  sans-serif;
}
input.mainoption {
	background-color : #FAFAFA;
	font-weight : bold;
}
-->
</style>
</head>
<body bgcolor="#FFFFFF" text="#000000" link="#006699" vlink="#5584AA">

<table width="100%" border="0" cellspacing="0" cellpadding="10" align="center"> 
	<tr>
		<td><table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td><img src="../templates/subSilver/images/logo_phpBB.gif" border="0" alt="Forum Home" vspace="1" /></td>
				<td align="center" width="100%" valign="middle"><span class="maintitle">Automatic AttachMOD 1.0 <span style="color:#d00">beta</span> installer by Alek$</span></td>
			</tr>
		</table></td>
	</tr>
</table>

<br clear="all" />

<table width="100%" border="0" cellspacing="0" cellpadding="10" align="center"> 
	<tr>
		<td>
<?php
ob_start();

//include("class.vd.php");
define("PHPBB_PATH", realpath("../").'/');
define("PROCESS_PATH", realpath("./proc").'/');

include("libMODparser.php");

$step = empty($_GET['step'])?0:$_GET['step'];

if($step == 1)
{
//TODO: phpBB2 -> PHPBB_PATH
	$parser = new MODparser();
	
	echo '<h1>Step One</h1>';
	echo '<table border="0" cellspacing="0" rules="all" cellpadding="10" align="left"><tr valign="top"><td>';
	echo 'Loading MOD into memory...&nbsp;&nbsp;&nbsp;&nbsp;</td><td colspan="2">';
	if( !$parser->load(PHPBB_PATH."attachment_mod/docs/install.txt") )
	{
		echo '<b>[ FAILED ]</b></td></tr></table>';
	}
	else
	{
		echo '<b class="ok">[ SUCCESS ]</b></td></tr><tr valign="top"><td>';
		echo 'Parsing MOD script...&nbsp;&nbsp;&nbsp;&nbsp;</td><td colspan="2">';
		$parser->basedir = PHPBB_PATH;
		if( !$parser->parse() )
		{
			echo '<b>[ FAILED ]</b></td></tr></table>';
		}
		else
		{
			echo '<b class="ok">[ SUCCESS ]</b></td></tr><tr valign="top"><td>';
			echo 'Processing files...&nbsp;&nbsp;&nbsp;&nbsp;</td><td>';
			if( !$parser->process(PHPBB_PATH, PROCESS_PATH) )
			{
				echo '</td><td width="50%"><b>[ FAILED ]</b>:<br><pre style="overflow: auto">'.nl2br($parser->getErrorInfo()).'</pre></td></tr></table>';
			}
			else
			{
				echo '</td><td><b class="ok"><nobr>[ SUCCESS ]</nobr></b></td></tr>';
				echo '<tr><td align="center" colspan="3"><br /><input type="button" class="mainoption" value="Step 2 - copy files!" onclick="document.location.href=\'?step=2\'"></td></tr></table><br clear="all" />';
			}
		}
	}
}
else if( $step == 2 )
{
	define('SILENT', true);
	$parser = new MODparser();
	$parser->load(PHPBB_PATH."attachment_mod/docs/install.txt");
	$parser->basedir = PHPBB_PATH;
	$parser->parse();
	$parser->process(PHPBB_PATH, PROCESS_PATH);
	
	echo '<h1>Step Tow</h1>';
	echo '<table border="0" cellspacing="0" cellpadding="0" align="left"><tr><td>';
	echo 'Copying files...&nbsp;&nbsp;&nbsp;&nbsp;</td><td>';
	if( !$parser->install(PROCESS_PATH, PHPBB_PATH) )
	{
		echo '<b>[ FAILED ]</b><br><pre>Errcode:'.$parser->errno.'<br>Errinfo:'.$parser->errinfo.'</pre></td></tr></table>';
	}
	else
	{
		echo '<b class="ok">[ SUCCESS ]</b></td></tr>';
		echo '<tr><td align="center"><br /><input type="button" class="mainoption" value="Step 3 - update database!" onclick="document.location.href=\'?step=3\'"></td></tr></table><br clear="all" />';
	}
}
else if( $step == 3 )
{
	echo '<h1>Step Three</h1>';
	ob_start();
	
	$dir = getcwd();
	chdir( PHPBB_PATH."/install" );
	
	$err = error_reporting(0);
	include("install.php");
	$ob = ob_get_clean();
	error_reporting( $err );
	chdir( $dir );
	
	$patterns[] = "/&nbsp;/";
	$patterns[] = "/[\s]+/";
	$patterns[] = "/(<[\/]?(p|br|h[1-6])[^>]*>)/";
	$patterns[] = "/<!DOCTYPE[^>]*>/";
	$patterns[] = "/(<head>.*<\/head>)/s";
	$patterns[] = "/(<[\/]?[^\s][^>]*>)/";
	
	$replacement[] = " ";
	$replacement[] = " ";
	$replacement[] = "\n";
	
	$ob = preg_replace( $patterns , $replacement, $ob);
	
	$patterns = array();
	$patterns[] = "/[ ]+/";
	$patterns[] = "/\n /";
	
	$replacement = array();
	$replacement[] = " ";
	$replacement[] = "\n";
	
	$ob = preg_replace( $patterns , $replacement, $ob);
	
	$ob = trim( $ob );
	
	echo '<h3>MySQL update report:</h3><tt>'.nl2br($ob).'</tt>';
	if($errored)
	{
		echo '<h3>There are some errors occured during database updating. Please, update database manualy</h3>';
	}
	echo '<br clear="all" /><input type="button" class="mainoption" value="Step 4 - finish!" onclick="document.location.href=\'?step=4\'">';
}
else if($step == 4)
{
	echo '<h1>Step Four</h1>';
	echo 'Installation complite!<br />Now remove installer files from your server:<br /><tt>';
	echo 'Folder: ' . realpath(PHPBB_PATH."/attachment_mod") .'<br />';
	echo 'Folder: ' . realpath(PHPBB_PATH."/install") .'<br />';
	echo '</tt>';
	?>
	<h3>Credits:</h3>
	<p>
	&copy; <a href="mailto:dy-sky@ya.ru">Alek$</a>, <a href="http://aradmin.org">Aradmin Software</a> - 2007<br /><br />
	This program is free, so I don't require anything, but it would be very nice of you, if you place this code in any place on your board:
	<div style="border: solid 1px #aaa; padding: 10px"><tt>
	&#060;small&#062;&#060;a href="http://aradmin.org"&#062;AttachMOD installer&#060;/a&#062; &copy; by Alek$&#060;/small&#062;
	</tt></div><br />
	It will look like that:<br /><br />
	<div style="border: solid 1px #aaa; padding: 10px">
	<small><a href="http://aradmin.org">AttachMOD installer</a> &copy; by Alek$</small>
	</div>
	</p>
	<?php
	
}
else
{
	$passed = true;
	?>
	<div style="border: solid 1px #d00; padding: 10px">
	<span style="font-weight:bold;color:#d00">Warning!</span><br>
	<span style="color:#d00">This is BETA software!</span><br >
	This software is free and as such comes without warranty as stated in the GNU GPL License (included in this package). Any problems encountered due to deficiencies in this software are not the responsibility of the author.<br />
	<br />
	<b>Create backup of your board files and database before using this script!</b>
	</div>
	<h1>Step Zero</h1>
	<h3>Checking directories</h3>
	<?php
	
	$dirs[] = PROCESS_PATH.'';
	$dirs[] = PHPBB_PATH.'';
	$dirs[] = PHPBB_PATH.'admin';
	$dirs[] = PHPBB_PATH.'images';
	$dirs[] = PHPBB_PATH.'includes';
	$dirs[] = PHPBB_PATH.'templates/subSilver';
	$dirs[] = PHPBB_PATH.'templates/subSilver/admin';
	$dirs[] = PHPBB_PATH.'language/lang_english';
	$dirs[] = PHPBB_PATH.'language/lang_russian';
	
	echo '<table border="0" cellspacing="0" cellpadding="0" align="left">';
	foreach( $dirs as $dir )
	{
		echo '<tr><td>'.$dir.'&nbsp;&nbsp;&nbsp;&nbsp;</td><td>';
		if(is_writeable($dir))
		{
			echo '<b><span class="ok">Writeable</span></b>';
		}
		else
		{
			echo '<b>Not writeable</b>';
			$passed = false;
		}
		echo '</td></tr>';
	}
	echo '</table><br clear="all" />';

	echo '<h3>Checking files</h3>';
	
	$files[] = PHPBB_PATH.'common.php';
	$files[] = PHPBB_PATH.'faq.php';
	$files[] = PHPBB_PATH.'modcp.php';
	$files[] = PHPBB_PATH.'posting.php';
	$files[] = PHPBB_PATH.'privmsg.php';
	$files[] = PHPBB_PATH.'viewforum.php';
	$files[] = PHPBB_PATH.'viewtopic.php';
	$files[] = PHPBB_PATH."admin/admin_forumauth.php";
	$files[] = PHPBB_PATH."admin/admin_ug_auth.php";
	$files[] = PHPBB_PATH."admin/admin_forums.php";
	$files[] = PHPBB_PATH."admin/admin_groups.php";
	$files[] = PHPBB_PATH."admin/admin_users.php";
	$files[] = PHPBB_PATH."includes/auth.php";
	$files[] = PHPBB_PATH."includes/functions.php";
	$files[] = PHPBB_PATH."includes/functions_admin.php";
	$files[] = PHPBB_PATH."includes/prune.php";
	$files[] = PHPBB_PATH."includes/topic_review.php";
	$files[] = PHPBB_PATH.'includes/usercp_viewprofile.php';
	$files[] = PHPBB_PATH.'templates/subSilver/modcp_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/posting_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/posting_preview.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/posting_topic_review.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/privmsgs_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/privmsgs_preview.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/privmsgs_read_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/profile_view_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/viewforum_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/viewtopic_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/admin/group_edit_body.tpl';
	$files[] = PHPBB_PATH.'templates/subSilver/admin/user_edit_body.tpl';
	
	echo '<table border="0" cellspacing="0" cellpadding="0" align="left">';
	foreach( $files as $file )
	{
		echo '<tr><td>'.$file.'&nbsp;&nbsp;&nbsp;&nbsp;</td><td>';
		if(is_writeable($file))
		{
			echo '<b><span class="ok">Writeable</span></b>';
		}
		else
		{
			$passed = false;
			echo '<b>Not writeable</b>';
		}
		echo '</td></tr>';
	}
	echo '</table><br clear="all" />';
	if( $passed ) {
		echo '<p align="center"><input type="button" class="mainoption" value="Step 1 - process!" onclick="document.location.href=\'?step=1\'"></p>';
	}
}
?>
		</td>
	</tr>
</table>
<br />
</body>
</html>
